#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_everyday_task.h"
std::auto_ptr<M_everyday_task> M_everyday_task::msSingleton(nullptr);

int M_everyday_task::GetCount()
{
	return (int)mMapData.size();
}

const M_everyday_taskData* M_everyday_task::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_everyday_taskData>& M_everyday_task::GetMapData()
{
	return mMapData;
}

void M_everyday_task::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_everyday_task.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_everyday_taskData data;
		data.mID = element->IntAttribute("ID");
		data.mtaskType = element->IntAttribute("taskType");
		data.mdes = element->Attribute("des");
		{
			const char* reward = element->Attribute("reward");
			std::vector<std::string> vecreward;
			boost::split(vecreward, reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecreward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecreward[i].c_str(), &temp))
				{
					data.mreward.push_back(temp);
				}
			}
		}
		data.munlock = element->IntAttribute("unlock");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_everyday_task Loaded. Load Data:%u", mMapData.size());
}

void M_everyday_task::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_everyday_task");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_everyday_task");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_everyday_taskData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "taskType", data.mtaskType);
		LuaCfgHelper::readString(L, "des", data.mdes);
		LuaCfgHelper::readVectorInt(L, "reward", data.mreward);
		LuaCfgHelper::readInt(L, "unlock", data.munlock);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_everyday_task Loaded. Load Data:%u", mMapData.size());
}

void M_everyday_task::Reload()
{
	mMapData.clear();
	Load();
}

M_everyday_task* M_everyday_task::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_everyday_task());
	}
	return msSingleton.get();
}

void M_everyday_task::Release()
{
	msSingleton.reset(nullptr);
}
